## samba 4.23.3+dfsg

=== python/wscript ===
#!/usr/bin/env python

import os
from waflib import Options, Errors

# work out what python external libraries we need to be successful
selftest_pkgs = {
    'cryptography': 'python3-cryptography',
    'pyasn1': 'python3-pyasn1'
}

ad_dc_pkgs = {
    'markdown': 'python3-markdown',
    'dns': 'python3-dnspython (python3-dns on some systems)'
}


def find_third_party_module(conf, module, package, required=True):
    conf.COMPOUND_START("Checking for system installation of Python module %s" % module)
    try:
        __import__(module)
    except ImportError:
        conf.COMPOUND_END(False)
        if not required:
            return False
        raise Errors.WafError("""\
        Unable to find Python module '%s'. Please install the system package: %s'.
""" % (module, package))
    else:
        # Installed on the system
        conf.COMPOUND_END("system")

    return True


def configure(conf):
    if conf.env.disable_python:
        return

    kerberos_py = conf.srcnode.abspath() + "/python/samba/provision/kerberos_implementation.py"

    f = open(kerberos_py, 'w')
    try:
        header = """#
# Copyright (c) 2016      Andreas Schneider <asn@samba.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
"""
        f.write(header)

        data = """kdb_modules_dir = "{0}"
"""

        if conf.env.HEIMDAL_KRB5_CONFIG:
            f.write(data.format(""))
        else:
            modulesdir = "%s/krb5/plugins/kdb" % conf.env.LIBDIR

            f.write(data.format(modulesdir))
    finally:
        f.close()

    if conf.CONFIG_GET('ENABLE_SELFTEST'):
        for module, package in selftest_pkgs.items():
            find_third_party_module(conf, module, package)

        # Prefer dateutil.parser which is much more widely used.
        if not find_third_party_module(conf,
                                       'dateutil.parser',
                                       'python3-dateutilis',
                                       required=False):
            if not find_third_party_module(conf,
                                           'iso8601',
                                           'python3-iso8601',
                                           required=False):
                raise Errors.WafError("Could not find Python package "
                                      "'python3-dateutils' nor "
                                      "'python3-iso8601'. Please install "
                                      "one of the packages.")

    if not Options.options.without_ad_dc:
        for module, package in ad_dc_pkgs.items():
            find_third_party_module(conf, module, package)


def build(bld):


    pytalloc_util = bld.pyembed_libname('pytalloc-util')
    pyparam_util = bld.pyembed_libname('pyparam_util')
    libpython = bld.pyembed_libname('LIBPYTHON')
    pyrpc_util = bld.pyembed_libname('pyrpc_util')
    samba_python = bld.pyembed_libname('samba_python')
    bld.SAMBA_LIBRARY(samba_python,
                      source=[],
                      deps='%s %s %s' % (libpython, pytalloc_util, pyrpc_util),
                      grouping_library=True,
                      private_library=True,
                      pyembed=True,
                      enabled=bld.PYTHON_BUILD_IS_ENABLED())
    bld.SAMBA_PYTHON('python_glue',
                     source='pyglue.c',
                     deps='''
                              %s
                              samba-util
                              netif
                              ndr
                              cmdline
                              gkdi
                              util_crypt
                              %s
                              ''' % (pyparam_util, pytalloc_util),
                     realname='samba/_glue.so')

    bld.SAMBA_SUBSYSTEM(libpython,
                        source='modules.c',
                        public_deps='',
                        init_function_sentinel='{NULL,NULL}',
                        deps='talloc',
                        pyext=True,
                        enabled=bld.PYTHON_BUILD_IS_ENABLED())

    if bld.PYTHON_BUILD_IS_ENABLED():
        # install out various python scripts for use by make test
        bld.SAMBA_SCRIPT('samba_python_files',
                         pattern='samba/**/*.py',
                         installdir='python')

        bld.INSTALL_WILDCARD('${PYTHONARCHDIR}', 'samba/**/*.py', flat=False)

=== lib/cmdline/wscript ===
#!/usr/bin/env python

import os
import sys
from waflib import Logs

def build(bld):
    bld.SAMBA_LIBRARY('cmdline',
                      source='''
                          cmdline.c
                          closefrom_except.c
                      ''',
                      deps='''
                           talloc
                           cli_smb_common
                           samba-hostconfig
                           samba-credentials
                           CREDENTIALS_CMDLINE
                           popt
                           ''',
                      private_library=True)

    bld.SAMBA_SUBSYSTEM('CMDLINE_S3',
                        source='cmdline_s3.c',
                        deps='cmdline secrets3')

    bld.SAMBA_SUBSYSTEM('CMDLINE_S4',
                        source='cmdline_s4.c',
                        deps='cmdline samba3core')

    bld.SAMBA_BINARY('test_cmdline',
                     source='tests/test_cmdline.c',
                     deps='cmocka CMDLINE_S3 LOADPARM_CTX',
                     local_include=False,
                     for_selftest=True)

=== third_party/ngtcp2/wscript ===
#!/usr/bin/env python

import sys
from waflib import Logs
from samba_utils import save_file

def configure(conf):
    if not sys.platform.startswith('linux'):
        Logs.warn('libngtcp2 requires linux')
        conf.SET_TARGET_TYPE('ngtcp2', 'EMPTY')
        return

    if not conf.CONFIG_GET('HAVE_GNUTLS_CB_TLS_SERVER_END_POINT'):
        Logs.warn('libngtcp2 requires gnutls 3.7.2')
        conf.SET_TARGET_TYPE('ngtcp2', 'EMPTY')
        return

    if conf.CHECK_LIBNGTCP2():
        conf.DEFINE('HAVE_LIBNGTCP2', '1')
        conf.define('USING_SYSTEM_LIBNGTCP2', 1)
        return

    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-cast-qual',
                          testflags=True)
    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-error=cast-qual',
                          testflags=True)
    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-strict-aliasing',
                          testflags=True)
    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-error=strict-aliasing',
                          testflags=True)
    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-strict-overflow',
                          testflags=True)
    conf.ADD_NAMED_CFLAGS('LIBNGTCP2_UNPICKY_CFLAGS',
                          '-Wno-error=strict-overflow',
                          testflags=True)

    conf.DEFINE('HAVE_LIBNGTCP2', '1')
    return

def build(bld):
    if bld.CONFIG_SET('USING_SYSTEM_LIBNGTCP2'):
        return

    def generate_ngtcp2_version_h(task):
        ngtcp2_version_h = task.outputs[0].bldpath(task.env)
        h = '''
        #ifndef NGTCP2_VERSION_H
        #define NGTCP2_VERSION_H
        #define NGTCP2_VERSION "1.11.0"
        #define NGTCP2_VERSION_NUM 0x010b00
        #endif
        '''

        save_file(ngtcp2_version_h, h, create_dir=True)
        return 0

    ngtcp2_version_h = 'lib/includes/ngtcp2/version.h'
    bld.SAMBA_GENERATOR(ngtcp2_version_h,
                        target=ngtcp2_version_h,
                        rule=generate_ngtcp2_version_h,
                        enabled=bld.CONFIG_SET('HAVE_LIBNGTCP2'))

    bld.SAMBA_LIBRARY('ngtcp2',
                      source='''
                      lib/ngtcp2_acktr.c
                      lib/ngtcp2_addr.c
                      lib/ngtcp2_balloc.c
                      lib/ngtcp2_bbr.c
                      lib/ngtcp2_buf.c
                      lib/ngtcp2_cc.c
                      lib/ngtcp2_cid.c
                      lib/ngtcp2_conn.c
                      lib/ngtcp2_conv.c
                      lib/ngtcp2_crypto.c
                      lib/ngtcp2_dcidtr.c
                      lib/ngtcp2_err.c
                      lib/ngtcp2_frame_chain.c
                      lib/ngtcp2_gaptr.c
                      lib/ngtcp2_idtr.c
                      lib/ngtcp2_ksl.c
                      lib/ngtcp2_log.c
                      lib/ngtcp2_map.c
                      lib/ngtcp2_mem.c
                      lib/ngtcp2_objalloc.c
                      lib/ngtcp2_opl.c
                      lib/ngtcp2_path.c
                      lib/ngtcp2_pkt.c
                      lib/ngtcp2_pmtud.c
                      lib/ngtcp2_ppe.c
                      lib/ngtcp2_pq.c
                      lib/ngtcp2_pv.c
                      lib/ngtcp2_qlog.c
                      lib/ngtcp2_range.c
                      lib/ngtcp2_ringbuf.c
                      lib/ngtcp2_rob.c
                      lib/ngtcp2_rst.c
                      lib/ngtcp2_rtb.c
                      lib/ngtcp2_settings.c
                      lib/ngtcp2_str.c
                      lib/ngtcp2_strm.c
                      lib/ngtcp2_transport_params.c
                      lib/ngtcp2_unreachable.c
                      lib/ngtcp2_vec.c
                      lib/ngtcp2_version.c
                      lib/ngtcp2_window_filter.c
                      ''',
                      includes='crypto/includes lib/includes crypto lib',
                      deps='replace',
                      cflags_end=bld.env.LIBNGTCP2_UNPICKY_CFLAGS,
                      private_library=True,
                      enabled=bld.CONFIG_SET('HAVE_LIBNGTCP2'))
    bld.SAMBA_SUBSYSTEM('libngtcp2', source='', public_deps='ngtcp2',
                        enabled=bld.CONFIG_SET('HAVE_LIBNGTCP2'))
    bld.SAMBA_LIBRARY('ngtcp2_crypto_gnutls',
                      source='''
                      crypto/shared.c
                      crypto/gnutls/gnutls.c
                      ''',
                      includes='crypto/includes lib/includes crypto lib',
                      deps='replace',
                      public_deps='libngtcp2 gnutls',
                      cflags_end=bld.env.LIBNGTCP2_UNPICKY_CFLAGS,
                      private_library=True,
                      enabled=bld.CONFIG_SET('HAVE_LIBNGTCP2'))
    bld.SAMBA_SUBSYSTEM('libngtcp2_crypto_gnutls', source='', public_deps='ngtcp2_crypto_gnutls',
                        enabled=bld.CONFIG_SET('HAVE_LIBNGTCP2'))

=== third_party/pam_wrapper/wscript ===
#!/usr/bin/env python

import os

VERSION = "1.1.8"


def find_library(library_names, lookup_paths):
    for directory in lookup_paths:
        for filename in library_names:
            so_path = os.path.join(directory, filename)
            if os.path.exists(so_path):
                return so_path
    return ''

def configure(conf):
    if conf.CHECK_PAM_WRAPPER():
        conf.DEFINE('USING_SYSTEM_PAM_WRAPPER', 1)
        libpam_wrapper_so_path = 'libpam_wrapper.so'

        pam_set_items_so_path = find_library(['pam_set_items.so'],
                                             ['/usr/lib64/pam_wrapper', '/usr/lib/pam_wrapper'])
        pam_matrix_so_path = find_library(['pam_matrix.so'],
                                          ['/usr/lib64/pam_wrapper', '/usr/lib/pam_wrapper'])
    else:
        conf.CHECK_HEADERS('gnu/lib-names.h')

        if conf.CONFIG_SET("HAVE___THREAD"):
            conf.DEFINE("HAVE_GCC_THREAD_LOCAL_STORAGE", 1)

        # check HAVE_FUNCTION_ATTRIBUTE_FORMAT
        conf.CHECK_CODE('''
            void log_fn(const char *format, ...) __attribute__ ((format (printf, 1, 2)));

            int main(void) {
                return 0;
            }
            ''',
            'HAVE_FUNCTION_ATTRIBUTE_FORMAT',
            addmain=False,
            strict=True,
            msg='Checking for printf format validation support')

        conf.CHECK_HEADERS('security/pam_appl.h')
        conf.CHECK_HEADERS('security/pam_modules.h')
        conf.CHECK_HEADERS('security/pam_ext.h')

        conf.CHECK_FUNCS_IN('pam_vsyslog',
                            'pam',
                            checklibc=False,
                            headers='security/pam_ext.h')

        conf.CHECK_FUNCS_IN('pam_syslog',
                            'pam',
                            checklibc=False,
                            headers='security/pam_ext.h')

        conf.CHECK_FUNCS_IN('pam_start_confdir',
                            'pam',
                            checklibc=False,
                            headers='security/pam_appl.h')

        conf.CHECK_C_PROTOTYPE('pam_vprompt',
                               'int pam_vprompt(const pam_handle_t *_pamh, int _style, char **_resp, const char *_fmt, va_list _ap)',
                               define='HAVE_PAM_VPROMPT_CONST', headers='stdio.h sys/types.h security/pam_appl.h security/pam_modules.h')

        conf.CHECK_C_PROTOTYPE('pam_prompt',
                               'int pam_prompt(const pam_handle_t *_pamh, int _style, char **_resp, const char *_fmt, ...)',
                               define='HAVE_PAM_PROMPT_CONST', headers='stdio.h sys/types.h security/pam_appl.h security/pam_modules.h')

        conf.CHECK_C_PROTOTYPE(
            'pam_strerror',
            'const char *pam_strerror(const pam_handle_t *pamh, int errnum)',
            define='HAVE_PAM_STRERROR_CONST',
            headers='''stdio.h sys/types.h security/pam_appl.h
                       security/pam_modules.h''')

        # Find the absolute path to libpam.so.0
        libpam_path = find_library(['libpam.so.0', 'libpam.so'], conf.env.STANDARD_LIBPATH)
        conf.DEFINE('PAM_LIBRARY', ('"%s"' % libpam_path ))

        # Create full path to pam_wrapper
        blddir = os.path.realpath(conf.bldnode.abspath())
        libpam_wrapper_so_path = blddir + '/default/third_party/pam_wrapper/libpam-wrapper.so'
        pam_set_items_so_path = blddir + '/default/third_party/pam_wrapper/libpam-set-items.so'
        pam_matrix_so_path = blddir + '/default/third_party/pam_wrapper/libpam-matrix.so'

    conf.DEFINE('LIBPAM_WRAPPER_SO_PATH', libpam_wrapper_so_path)
    conf.DEFINE('PAM_SET_ITEMS_SO_PATH', pam_set_items_so_path)
    conf.DEFINE('PAM_MATRIX_SO_PATH', pam_matrix_so_path)
    conf.DEFINE('PAM_WRAPPER', 1)

def build(bld):
    if not bld.CONFIG_SET("USING_SYSTEM_PAM_WRAPPER"):
        # We need to do it this way or the library wont work.
        # We need force_unversioned=True as symbol versioning
        # breaks preloading!
        bld.SAMBA_LIBRARY('pam_wrapper',
                          source='pam_wrapper.c',
                          deps='dl pthread',
                          install=False,
                          force_unversioned=True,
                          realname='libpam-wrapper.so')

        bld.SAMBA_SUBSYSTEM('libpamtest',
                            source='libpamtest.c',
                            deps='dl pam')

        bld.SAMBA_LIBRARY('pam_set_items',
                          source='modules/pam_set_items.c',
                          deps='pam',
                          install=False,
                          force_unversioned=True,
                          realname='pam_set_items.so')
        bld.SAMBA_LIBRARY('pam_matrix',
                          source='modules/pam_matrix.c',
                          deps='pam',
                          install=False,
                          force_unversioned=True,
                          realname='pam_matrix.so')

        pypamtest_cflags = ''
        if bld.CONFIG_SET('HAVE_WNO_ERROR_DECLARATION_AFTER_STATEMENT'):
            pypamtest_cflags = '-Wno-error=declaration-after-statement'

        # Can be used to write pam tests in python
        bld.SAMBA_PYTHON('pypamtest',
                         source='python/pypamtest.c',
                         cflags_end=pypamtest_cflags,
                         deps='libpamtest',
                         install=False)

=== third_party/ngtcp2/lib/CMakeLists.txt ===

# ngtcp2

# Copyright (c) 2016 ngtcp2

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

add_subdirectory(includes)

add_definitions(-DBUILDING_NGTCP2)

set(ngtcp2_SOURCES
  ngtcp2_pkt.c
  ngtcp2_conv.c
  ngtcp2_str.c
  ngtcp2_vec.c
  ngtcp2_buf.c
  ngtcp2_conn.c
  ngtcp2_mem.c
  ngtcp2_pq.c
  ngtcp2_map.c
  ngtcp2_rob.c
  ngtcp2_ppe.c
  ngtcp2_crypto.c
  ngtcp2_err.c
  ngtcp2_range.c
  ngtcp2_acktr.c
  ngtcp2_rtb.c
  ngtcp2_frame_chain.c
  ngtcp2_strm.c
  ngtcp2_idtr.c
  ngtcp2_gaptr.c
  ngtcp2_ringbuf.c
  ngtcp2_log.c
  ngtcp2_qlog.c
  ngtcp2_cid.c
  ngtcp2_ksl.c
  ngtcp2_cc.c
  ngtcp2_bbr.c
  ngtcp2_addr.c
  ngtcp2_path.c
  ngtcp2_pv.c
  ngtcp2_pmtud.c
  ngtcp2_version.c
  ngtcp2_rst.c
  ngtcp2_window_filter.c
  ngtcp2_opl.c
  ngtcp2_balloc.c
  ngtcp2_objalloc.c
  ngtcp2_unreachable.c
  ngtcp2_transport_params.c
  ngtcp2_settings.c
  ngtcp2_dcidtr.c
)

set(ngtcp2_INCLUDE_DIRS
  "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/includes"
)

set(NGTCP2_GENERATED_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(NGTCP2_VERSION_CONFIG "${NGTCP2_GENERATED_DIR}/${PROJECT_NAME}ConfigVersion.cmake")
set(NGTCP2_PROJECT_CONFIG "${NGTCP2_GENERATED_DIR}/${PROJECT_NAME}Config.cmake")
set(NGTCP2_TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
set(NGTCP2_CONFIG_INSTALL_DIR "lib/cmake/${PROJECT_NAME}")
set(NGTCP2_NAMESPACE "${PROJECT_NAME}::")
set(NGTCP2_VERSION ${PROJECT_VERSION})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${NGTCP2_VERSION_CONFIG}" VERSION ${NGTCP2_VERSION} COMPATIBILITY SameMajorVersion
)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in" "${NGTCP2_PROJECT_CONFIG}" @ONLY)

# Install cmake config files
install(
  FILES "${NGTCP2_PROJECT_CONFIG}" "${NGTCP2_VERSION_CONFIG}"
  DESTINATION "${NGTCP2_CONFIG_INSTALL_DIR}")

# Public shared library
if(ENABLE_SHARED_LIB)
  add_library(ngtcp2 SHARED ${ngtcp2_SOURCES})
  set_target_properties(ngtcp2 PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    C_VISIBILITY_PRESET hidden
    POSITION_INDEPENDENT_CODE ON
  )
  foreach(include_DIR IN LISTS ngtcp2_INCLUDE_DIRS)
    target_include_directories(ngtcp2 PUBLIC $<BUILD_INTERFACE:${include_DIR}>)
  endforeach()

  target_include_directories(ngtcp2 PUBLIC $<INSTALL_INTERFACE:./include>)

  install(TARGETS ngtcp2
    EXPORT ${NGTCP2_TARGETS_EXPORT_NAME}
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_STATIC_LIB)
  # Public static library
  add_library(ngtcp2_static STATIC ${ngtcp2_SOURCES})
  set_target_properties(ngtcp2_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    ARCHIVE_OUTPUT_NAME ngtcp2${STATIC_LIB_SUFFIX}
    C_VISIBILITY_PRESET hidden
  )
  target_compile_definitions(ngtcp2_static PUBLIC "-DNGTCP2_STATICLIB")
  foreach(include_DIR IN LISTS ngtcp2_INCLUDE_DIRS)
    target_include_directories(ngtcp2_static PUBLIC $<BUILD_INTERFACE:${include_DIR}>)
  endforeach()

  target_include_directories(ngtcp2_static PUBLIC $<INSTALL_INTERFACE:./include>)

  install(TARGETS ngtcp2_static
    EXPORT ${NGTCP2_TARGETS_EXPORT_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

install(
  EXPORT "${NGTCP2_TARGETS_EXPORT_NAME}"
  NAMESPACE "${NGTCP2_NAMESPACE}"
  DESTINATION "${NGTCP2_CONFIG_INSTALL_DIR}")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libngtcp2.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
samba (2:4.23.3+dfsg-1.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind

 -- anticapitalista <antix@operamail.com>  Sat, 08 Nov 2025 13:13:49 +0200

samba (2:4.23.3+dfsg-1) unstable; urgency=medium

  * new upstream stable/bugfix release:
   - https://bugzilla.samba.org/show_bug.cgi?id=15926:
     Samba 4.22 breaks Time Machine
   - https://bugzilla.samba.org/show_bug.cgi?id=15927:
     Spotlight search restriction for shares incomplete and
     default search searches in too many attributes
   - https://bugzilla.samba.org/show_bug.cgi?id=15930:
     Searching for numbers doesn't work with Spotlight
   - https://bugzilla.samba.org/show_bug.cgi?id=15931:
     rpcd_mdssvc may crash because name mangling is not initialized
   - https://bugzilla.samba.org/show_bug.cgi?id=15933:
     Only increment lease epoch if a lease was granted
   - https://bugzilla.samba.org/show_bug.cgi?id=15935:
     Crash in ctdbd on failed updateip
   - https://bugzilla.samba.org/show_bug.cgi?id=15940:
     vfs_recycle does not update mtime
   - https://bugzilla.samba.org/show_bug.cgi?id=15943:
     samba-log-parser fails with UnicodeDecodeError:
     'utf-8' codec can't decode byte

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 07 Nov 2025 16:45:53 +0300

=== debian/control ===
# Available build profiles:
#  pkg.samba.before-trixie: no t64, no usrmerge, no rpcsvc-proto
#  pkg.samba.builtin-ngtcp2: use built-in ngtcp2 (required version of libngtcp2 is >= 1.12.0)
#  pkg.samba.dumpmscat: build /usr/bin/dumpmscat binary
#  pkg.samba.mitkrb5: build with mit-krb5 kerberos instead of bundled heimdal
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://www.samba.org
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
	dh-exec,
Build-Depends-Arch:
	dpkg-dev (>= 1.22.5) <!pkg.samba.before-trixie>,
# tools:
	bison,
	docbook-xml, docbook-xsl, xsltproc,
	flex,
	perl:any,
# :native for bookworm where the package in question does not have M-A markings:
	libparse-yapp-perl:native | libparse-yapp-perl,
	rpcsvc-proto  <!pkg.samba.before-trixie>,
# for winexe. gcc-mingw-w64 brings 4 toolchains, we need only 2
# :native for trixie where the package in question does not have M-A markings:
	gcc-mingw-w64-i686-win32:native | gcc-mingw-w64-i686-win32,
	gcc-mingw-w64-x86-64-win32:native | gcc-mingw-w64-x86-64-win32,
# system libraries:
	pkgconf,
	libacl1-dev,
	libarchive-dev,
	libavahi-client-dev,
	libavahi-common-dev,
	libblkid-dev,
	libbsd-dev,
	libcap-dev [linux-any],
# the same [arch list] is in ctdb.install
	libcephfs-dev [amd64 arm64 mips64el ppc64el riscv64 s390x],
	librados-dev  [amd64 arm64 mips64el ppc64el riscv64 s390x],
	libcmocka-dev,
	libcrypt-dev,
	libcups2-dev,
	libdbus-1-dev,
	libglusterfs-dev [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
	libgnutls28-dev,
	libgpgme11-dev,
	libicu-dev,
	libjansson-dev,
	libkeyutils-dev [linux-any],
	libkrb5-dev (>= 1.21.0~) <pkg.samba.mitkrb5>,
	libldap2-dev,
	liblmdb-dev,
	libngtcp2-dev (>> 1.12.0~) [linux-any] <!pkg.samba.builtin-ngtcp2>,
	libngtcp2-crypto-gnutls-dev (>> 1.12.0~) [linux-any] <!pkg.samba.builtin-ngtcp2>,
	libpam0g-dev,
	libpcap-dev [hurd-any],
	libpopt-dev,
	libreadline-dev,
	libtirpc-dev,
	libtasn1-6-dev <pkg.samba.dumpmscat>,
	libtasn1-bin <pkg.samba.dumpmscat>,
	liburing-dev [linux-any],
# xfslibs-dev is not multi-arch-usable but we only need .h (#1092689)
	xfslibs-dev:native [linux-any],
	zlib1g-dev,
# python (+#904999):
# cross-build: native python environment, host-specific libpython-dev
# (see also d/rules, _PYTHON_SYSCONFIGDATA_NAME):
	python3-dev:native, libpython3-dev,
# :native for bookworm where the package in question does not have M-A markings:
	python3-dnspython:native | python3-dnspython,
	python3-etcd:native | python3-etcd,
	python3-markdown:native | python3-markdown,
	python3-setuptools,
	dh-sequence-python3,
# dependencies needed for selftest:
#	python3-testtools <!nocheck>,
#	lmdb-utils <!nocheck>,
#	openssl <!nocheck>,
#	python3-cryptography <!nocheck>,
#	python3-iso8601 <!nocheck>,
#	python3-pyasn1 <!nocheck>,
#	tdb-tools <!nocheck>,
Build-Conflicts-Arch:
 libngtcp2-dev <pkg.samba.builtin-ngtcp2>,
 libtasn1-bin <!pkg.samba.dumpmscat>,
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: passwd,
         samba-common,
         samba-common-bin (=${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: ctdb,
          ufw,
          winbind,
          python3-samba,
          samba-vfs-ceph, samba-vfs-glusterfs,
          attr,
# move libdfs-server-ad-samba4.so.0 samba-libs=>samba-vfs-modules in 4.19.0~rc1
# swallow samba-vfs-modules by samba in 4.20.2-dfsg-3
Replaces: samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
          samba-libs (<< 2:4.19.0~),
          samba-vfs-modules (<< 2:4.20.2+dfsg-3~),
          samba-ad-dc (<< 2:4.20.1+dfsg-2~),
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an Active Directory or NT4-style domain controller, and can integrate
 with Active Directory realms or NT4 domains as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 domain controller.  For use in an NT4
 domain or Active Directory realm, you will also need the winbind package.
 To use samba as an Active Directory domain controller (AD DC), please install
 samba-ad-dc package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Provides: libndr6 (= ${binary:Version}),
# libndr5=>6 dropped 3 long-unused KRB5_EDATA_NTSTATUS symbols
 libndr5 (= ${binary:Version}),
 libsmbldap2 (= ${binary:Version})
Depends: ${misc:Depends}, ${shlibs:Depends},
# since libldb ABI is incorrectly versioned resulting in breakage like #1021371,
# just require libldb version of the same build
# https://lists.samba.org/archive/samba-technical/2023-September/138422.html
 libldb2 (= ${ldb:Version}),
Breaks:
 sssd-ad (<< 2.9.4-1+b1),
 sssd-ad-common (<< 2.9.4-1+b1),
 sssd-ipa (<< 2.9.4-1+b1),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: samba-common,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-samba,
Suggests: heimdal-clients,
# moved libnet-keytab-samba4.so.0 & libRPC-WORKER-samba4.so.0 samba-libs=>samba-common-bin in 4.19.0~r1
# moved smbcontrol samba=>samba-common-bin in 4.20.0-2
# in kali linux, winexe initially has been in its own pkg (#1081269)
Replaces: samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Breaks:   samba (<< 2:4.20.1+dfsg-2~), samba-libs (<< 2:4.19.0~), winexe (<< 2:4.21.1+dfsg-3~)
Provides: winexe (= ${binary:Version})
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the smbclient
 package).

Package: samba-ad-dc
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: samba (= ${binary:Version}),
	 python3-samba (= ${binary:Version}),
	 python3-dnspython,
	 samba-dsdb-modules (= ${binary:Version}),
	 winbind (= ${binary:Version}),
	 krb5-kdc (>= 1.21.0~) <pkg.samba.mitkrb5>,
	 ${python3:Depends},
	 ${shlibs:Depends},
	 ${misc:Depends}
Recommends: libnss-winbind, libpam-winbind,
# samba-ad-provision is needed for setup only
	samba-ad-provision,
# used in a few AD-related subcommands of samba-tool (see #876984)
        python3-gpg,
Suggests: bind9,
	  bind9utils,
	  ldb-tools,
# Besides wanting accurate time, samba DC can provide signed time source
# to the domain using special socket (see "ntp signd socket directory"
# in smb.conf(5)).  There was a (wrong) patch to ntp to work with samba,
# it has been dropped in ntpsec.
	  time-daemon | chrony | ntpsec,
Enhances: bind9, ntpsec
Breaks:   samba-ad-provision (<< ${source:Upstream-Version}),
# files moved from samba & samba-common-bin in 4.20.1-2:
	  samba-common-bin (<< 2:4.20.1+dfsg-2~),
Replaces: samba-common-bin (<< 2:4.20.1+dfsg-2~),
# Breaks+Replaces upgraded to Conflicts for DEP17 + /usr-move
Conflicts: samba (<< 2:4.20.1+dfsg-2~),
Description: Samba control files to run AD Domain Controller
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains control files to run an Active Directory Domain
 Controller (AD DC).  For now, this is just a metapackage pulling in
 all the required dependencies.

Package: samba-ad-provision
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 python3-markdown,
Description: Samba files needed for AD domain provision
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains files to setup an Active Directory Domain
 Controller (AD DC).

Package: smbclient
Architecture: any
Depends: samba-common,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
# move libshares-samba4.so.0 samba-libs=>samba-testsuite in 4.19.0~rc1
Replaces: samba-libs (<< 2:4.19.0~)
Breaks:   samba-libs (<< 2:4.19.0~)
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# build is done in bin/default/ subdir
DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms gcc does not link with -latomic, resulting in
#   third_party/heimdal/lib/krb5/krcache.c.55.o: in function `krcc_get_principal':
#   third_party/heimdal/lib/krb5/krcache.c:1395: undefined reference to `__atomic_load_8'
#     ids.krcu_cache_and_princ_id = heim_base_atomic_load(&data->krc_cache_and_principal_id);
#   third_party/heimdal/lib/base/heimbase-atomics.h:
#     #include <stdatomic.h>
#     #define heim_base_atomic_load(x)        atomic_load((x))
# include a workaround for now
# (-latomic and <stdatomic.h> comes from gcc, --as-needed is already in use)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

ifneq (,$(filter m68k ,${DEB_HOST_ARCH}))
# without this, build fails with multiple messages like:
# foo.s:NNN: Error: Adjusted signed .word (0xb64a) overflows: `switch'-statement too large.
# when building third_party/heimdal/lib/asn1/asn1_rfc2459_asn1.c (generated)
# It would be best to enable this switch for a single file only (where it is needed)
DEB_CFLAGS_MAINT_APPEND += -mlong-jump-table-offsets
endif

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

ifeq (linux,${DEB_HOST_ARCH_OS})
ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif
endif

PYTHONDIR = /usr/lib/python3/dist-packages

DESTDIR = ${CURDIR}/debian/tmp

before-trixie := $(filter pkg.samba.before-trixie, ${DEB_BUILD_PROFILES})

subver-suffix := +samba${DEB_VERSION_UPSTREAM_REVISION}

# lib/ldb/wscript
ldb-upstream-version := 2.11.0
ldb-version = 2:${ldb-upstream-version}${subver-suffix}
ldb-packages := libldb2 libldb-dev ldb-tools python3-ldb

# lib/talloc/wscript
talloc-upstream-version := 2.4.3
talloc-version = 2:${talloc-upstream-version}${subver-suffix}
talloc-packages := libtalloc2 libtalloc-dev python3-talloc

# lib/tevent/wscript
tevent-upstream-version := 0.17.1
tevent-version = 2:${tevent-upstream-version}${subver-suffix}
libtevent := $(if ${before-trixie},libtevent0,libtevent0t64)
tevent-packages := ${libtevent} libtevent-dev

# lib/tdb/wscript
tdb-upstream-version := 1.4.14
tdb-version = 2:${tdb-upstream-version}${subver-suffix}
tdb-packages := libtdb1 tdb-tools libtdb-dev python3-tdb

extra-version-vars = \
	-Vldb:Version=${ldb-version} \

# used in libnss-winbind.install & libpam-winbind.install
export SYSLIBDIR = $(if ${before-trixie},/lib,/usr/lib)

omit-pkgs =

config-args = \
	--vendor-suffix=${DEB_VENDOR}-${DEB_VERSION_UPSTREAM_REVISION} \
	--prefix=/usr \
	--enable-fhs \
	--sysconfdir=/etc \
	--localstatedir=/var \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
	--datadir=/usr/share \
	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
	--with-pammodulesdir=${SYSLIBDIR}/${DEB_HOST_MULTIARCH}/security \
	--with-privatedir=/var/lib/samba/private \
	--with-smbpasswd-file=/etc/samba/smbpasswd \
	--with-piddir=/run/samba \
	--with-lockdir=/run/samba \
	--with-sockets-dir=/run/samba \
	--with-statedir=/var/lib/samba \
	--with-cachedir=/var/cache/samba \
	--with-pam \
	--with-syslog \
	--with-utmp \
	--with-winbind \
	--with-automount \
	--with-ldap \
	--with-ads \
	--with-gpgme \
	--enable-avahi \
	--enable-spotlight \
	--with-profiling-data \
	--disable-rpath --disable-rpath-install \
	--private-libraries=!ldb \
	--bundled-libraries=talloc,tevent,tdb \
	--pythondir=${PYTHONDIR} \
	--pythonarchdir=${PYTHONDIR} \
	\
	--with-cluster-support \
	--enable-etcd-reclock \
	--with-socketpath=/run/ctdb/ctdbd.socket \
	--with-logdir=/var/log/ctdb \

# some modules are linked statically by default (see default_static_module in wscript*),
# but they're often linked into other libraries, which might result in cyclic deps.
# Eg, vfs_dfs_samba4 is statically linked to libsmbd-base-private, which is part of
# samba-libs (not samba), because it is used by python3-samba too (smbd.cpython).
# Might consider using --with-shared-modules=ALL
# Other modules (vfs_nfs4acl_xattr) are not enabled by default (#930540).
config-args += \
	--with-shared-modules=vfs_dfs_samba4,vfs_nfs4acl_xattr,auth_samba4

ifeq (${DEB_HOST_ARCH_OS}, linux) # extra linux-specific features

config-args += \
	--with-quota \
	\

endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
omit-pkgs += ctdb libpam-winbind samba samba-ad-dc samba-testsuite samba-vfs-modules samba-vfs-ceph samba-vfs-glusterfs
endif

# we had t64 transition (libsmbclient => libsmbclient0) for trixie
libsmbclient := $(if ${before-trixie},libsmbclient,libsmbclient0)

mitkrb5-dep-pkgs :=
ifneq (,$(filter pkg.samba.mitkrb5, ${DEB_BUILD_PROFILES}))
config-args += \
	--with-system-mitkrb5 \
	--with-experimental-mit-ad-dc \
	--with-system-mitkdc=/usr/sbin/krb5kdc
# samba packages will have its own version suffix
mitkrb5-samba-ver = ${DEB_VERSION}mitkrb5
mitkrb5-dep-pkgs += samba-libs samba-dev
mitkrb5-dep-pkgs += samba samba-common-bin python3-samba
mitkrb5-dep-pkgs += samba-vfs-ceph samba-vfs-glusterfs
mitkrb5-dep-pkgs += samba-dsdb-modules
mitkrb5-dep-pkgs += ${libsmbclient} smbclient
mitkrb5-dep-pkgs += libnss-winbind libpam-winbind
mitkrb5-dep-pkgs += winbind libwbclient0
mitkrb5-dep-pkgs += samba-testsuite
mitkrb5-dep-pkgs += ctdb
endif

ifneq (,${omit-pkgs})
export DH_OPTIONS += $(addprefix -N, ${omit-pkgs})
endif
# ${build-pkgs} will honour arch/indep and the above list in ${DH_OPTIONS}
build-pkgs := $(shell dh_listpackages)

with-ceph := $(filter samba-vfs-ceph,${build-pkgs})
config-args += $(if ${with-ceph},\
	  --enable-cephfs --enable-ceph-reclock,\
	  --disable-cephfs)

binary binary-arch binary-indep \
install install-arch install-indep: %:
	dh $*

configure: bin/configured.stamp
.PHONY: configure
bin/configured.stamp:
	CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	PYTHON=python3 PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-python3-config \
	    ${WAF} -j1 -C configure ${config-args} || \
	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
# #1013205: https://lists.samba.org/archive/samba-technical/2022-November/137788.html
	rm -f third_party/heimdal/lib/gssapi/gssapi.h
	touch $@

build-arch: bin/built.stamp
bin/built.stamp: bin/configured.stamp
# samba build system is designed so that default build (what is produced
# by waf build) supposed to be run directly from the build directory,
# with all the paths pointing there.  At the install stage, quite some
# recompilation/relinking is done again, to adopt to the actual install
# paths. There's no need (for now) to build samba to be run from the build
# directory, so we use `waf install' here instead of `waf build'.
ifeq (,${mitkrb5-dep-pkgs})
# However, as of 4.16 and still 4.21, `waf install' without the build step fails,
# since it tries to run two executables which are not built.
# Build these two executables first, and build the install stage.
# This will pefrorm unnecessary/extra install step (into d/tmp), which
